{-# OPTIONS --no-termination-check 
  #-}

module Quote where
open import Syntax
open import SyntacticLemmas
open import Variables
open import Value
open import Evaluator
open import Weakening
open import IdentityEnvironment
open import Normal

mutual
  quote : forall {Γ σ} -> Val Γ σ -> Nf Γ σ
  quote (λv {σ = σ} t vs)  = 
    ncoe (λn (quote (ev t 
                        (wkˢ _ vs 
                        << 
                        coev (nev (var vZ)) 
                             (trans⁺ assoc⁺ (cong⁺ refl⁺ (comwkˢ _ vs))))))) 
         (trans⁺ (congΠ refl⁺ 
                        (cong⁺ refl⁺
                                (cong< (symˢ (comwkˢ _ vs)) 
                                       (trans (coh _ _) (sym (coh _ _)))))) 
                 (sym⁺ Π[]))
  quote (nev n)    = nen (quoteⁿ n) 
  quote (coev v p) = ncoe (quote v) p 

  quoteⁿ : forall {Γ σ} -> NeV Γ σ -> NeN Γ σ
  quoteⁿ (var x)    = nvar x 
  quoteⁿ (app {σ = σ}{τ = τ} n v) = 
    ncoeⁿ (napp (quoteⁿ n) (quote v)) 
          (cong⁺ refl⁺ (cong< reflˢ (cong (comquote v) reflˢ)))
  quoteⁿ (coen n p) = ncoeⁿ (quoteⁿ n) p 

  comquote : forall {Γ σ}(v : Val Γ σ) -> 
           nemb (quote v) ≡ emb v
  comquote (λv {σ = σ} t vs)  =
    trans 
      (coh _ _) 
      (trans 
        (congλ 
          refl⁺
          (trans 
            (comquote _)
            (trans (sym (comev t (wkˢ (σ [ embˢ vs ]⁺) vs 
                                  << 
                                  coev (nev (var vZ)) _)))
                   (cong
                     refl 
                     (cong< 
                       (symˢ (comwkˢ _ vs)) 
                       (trans (coh _ _) (sym (coh _ _))))))))
                 (trans (sym λ[]) (coh _ Π[]))) 
  comquote (nev n)    = comquoteⁿ n 
  comquote (coev v p) = 
    trans (coh _ _) (trans (comquote v) (sym (coh _ _))) 

  comquoteⁿ : forall {Γ σ}(n : NeV Γ σ) -> 
           nembⁿ (quoteⁿ n) ≡ embⁿ n
  comquoteⁿ (var x)    = refl 
  comquoteⁿ (app {σ = σ} n v)  = 
    trans (coh _ _) 
          (cong (congapp (comquoteⁿ n)) 
                (cong< reflˢ (cong (comquote v) reflˢ))) 
  comquoteⁿ (coen n p) = ir (comquoteⁿ n) 